// start
package metaheuristicOptimization.algorithms.ea.selection;

import java.util.Random;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.ea.ISelectionAlgorithm;

/** the tournament selection algorithm */
// end
public class TournamentSelection implements ISelectionAlgorithm { // start
  /** the k */
  private final int k;

  /**
   * the tournament selection
   * 
   * @param s
   *          the tournament size
   */
  public TournamentSelection(final int s) {
    super();
    this.k = s;
  }

  /** {@inheritDoc} */
  @Override
  // end
  public void select(final Individual<?, ?>[] pop, final Individual<?, ?>[] mate, final Random r) {
    int i, j;
    Individual<?, ?> x, y;

    for (i = 0; i < mate.length; i++) {
      x = pop[r.nextInt(pop.length)];
      for (j = 1; j < this.k; j++) {
        y = pop[r.nextInt(pop.length)];
        if (y.v < x.v) {
          x = y;
        }
      }
      mate[i] = x;
    }
  }
}
