// start
package metaheuristicOptimization.algorithms.ea.selection;

import java.util.Arrays;
import java.util.Random;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.ea.ISelectionAlgorithm;

/** the truncation selection algorithm */
// end
public class TruncationSelection implements ISelectionAlgorithm { // start

  /** the globally shared instance */
  public static final TruncationSelection INSTANCE = new TruncationSelection();

  /** the truncation selection */
  private TruncationSelection() {
    super();
  }

  /** {@inheritDoc} */
  @Override
  // end
  public void select(final Individual<?, ?>[] pop, final Individual<?, ?>[] mate, final Random r) {
    Arrays.sort(pop);
    System.arraycopy(pop, 0, mate, 0, mate.length);
  }
}
