// start
package metaheuristicOptimization.algorithms.pso;

import metaheuristicOptimization.Individual;

/**
 * An individual for the Particle Swarm Optimization algorithm
 * 
 * @param <X>
 *          the solution space
 */
// end
public class PSOIndividual<X> extends Individual<double[], X> {

  /** the velocity vector */
  public final double[] velocity;

  /** the best position seen by this individual */
  public final Individual<double[], X> best; // start

  /**
   * create
   * 
   * @param gen
   *          the initial genotype
   */
  public PSOIndividual(final double[] gen) {
    super();
    this.g = gen;
    this.velocity = new double[gen.length];
    this.best = new Individual<>();
    this.best.g = new double[gen.length];
  }
  // end
}
