package metaheuristicOptimization.examples.Rn;// start

import java.util.Arrays;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.de.DE;
import metaheuristicOptimization.searchSpaces.Rn.Rn;
import metaheuristicOptimization.searchSpaces.Rn.RnNullaryUniform;
import metaheuristicOptimization.searchSpaces.Rn.RnRecombineDEBin;
import metaheuristicOptimization.termination.MaxSteps;

// end
/** The diffrential evolution algorithm applied to the ugly function  */
public class DEOnUglyFunction {// start
  /** Run the test class
   * @param args
   *          the command line arguments */
  // end
  public static void main(final String[] args)  {
    final DE<double[]>    de      = new DE<>();      // create DE
    final UglyFunction    problem = new UglyFunction(); // the problem/objective
    final Rn              rn      = new Rn(-10d, 10d, 6);
        
    de.nullary     = new RnNullaryUniform(rn); // instantiate nullary search operation
    de.ternary     = new RnRecombineDEBin(rn, 0.3d, 0.5d);
    de.ps          = 100;
        
    for (int i = 1; i <= 100; i++) {           // let's do 100 runs
      de.termination = new MaxSteps(10000000); // for each run, allocate 10'000'000 steps
      Individual<double[], double[]> res = de.solve(problem); // invoke optimizer
      System.out.println("run " + i + //$NON-NLS-1$
          " has result quality " + res.v + 
          " and result " + Arrays.toString(res.x)); //$NON-NLS-1$
    }
  }
}
