package metaheuristicOptimization.examples.Rn;// start

import java.util.Arrays;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.pso.PSO;
import metaheuristicOptimization.searchSpaces.Rn.Rn;
import metaheuristicOptimization.searchSpaces.Rn.RnNullaryUniform;
import metaheuristicOptimization.termination.MaxSteps;

// end
/** The PSO  algorithm applied to the ugly function  */
public class PSOOnUglyFunction {// start
  /** Run the test class
   * @param args
   *          the command line arguments */
  // end
  public static void main(final String[] args)  {
    final PSO<double[]>   pso     = new PSO<>();      // create PSO
    final UglyFunction    problem = new UglyFunction(); // the problem/objective
    final Rn              rn      = new Rn(-10d, 10d, 6);
        
    pso.nullary = new RnNullaryUniform(rn); // instantiate nullary search operation
    pso.ps      = 100;
    pso.rn      = rn;
        
    for (int i = 1; i <= 100; i++) {           // let's do 100 runs
      pso.termination = new MaxSteps(10000000); // for each run, allocate 10'000'000 steps
      Individual<double[], double[]> res = pso.solve(problem); // invoke optimizer
      System.out.println("run " + i + //$NON-NLS-1$
          " has result quality " + res.v + 
          " and result " + Arrays.toString(res.x)); //$NON-NLS-1$
    }
  }
}
