// start
package metaheuristicOptimization.examples.binPacking;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.HC;
import metaheuristicOptimization.searchSpaces.permutations.PermutationNullaryUniform;
import metaheuristicOptimization.searchSpaces.permutations.PermutationUnarySwap;
import metaheuristicOptimization.termination.MaxSteps;

/** a simple test class applying the hill climber to the bin packing problem */
// end
public class HCOnBinPacking {// start
  /**
   * Run the test class
   * 
   * @param args
   *          the command line arguments
   */
  // end
  public static void main(final String[] args) {
    final HC<int[], int[]> hc = new HC<>();
    final BinPackingObjective f = BinPackingObjective.EXAMPLE_PROBLEM;

    hc.nullary = new PermutationNullaryUniform(f.objects.length);
    hc.unary = new PermutationUnarySwap();

    System.out.println("Hill Climbing");
    for (int i = 1; i < 100; i++) {
      hc.termination = new MaxSteps(100000);
      final Individual<int[], int[]> res = hc.solve(f);
      System.out.println(res.v);
    }
  }
}