// start
package metaheuristicOptimization.examples.binPacking;

import metaheuristicOptimization.Individual;
import metaheuristicOptimization.algorithms.RandomWalk;
import metaheuristicOptimization.searchSpaces.permutations.PermutationNullaryUniform;
import metaheuristicOptimization.searchSpaces.permutations.PermutationUnarySwap;
import metaheuristicOptimization.termination.MaxSteps;

/** a simple test class applying the random walk to the bin packing problem */
// end
public class RaWaOnBinPacking {// start
  /**
   * Run the test class
   * 
   * @param args
   *          the command line arguments
   */
  // end
  public static void main(final String[] args) {
    final RandomWalk<int[], int[]> rw = new RandomWalk<>();
    final BinPackingObjective f = BinPackingObjective.EXAMPLE_PROBLEM;

    rw.nullary = new PermutationNullaryUniform(f.objects.length);
    rw.unary = new PermutationUnarySwap();

    System.out.println("Random Walk");
    for (int i = 1; i < 100; i++) {
      rw.termination = new MaxSteps(100000);
      final Individual<int[], int[]> res = rw.solve(f);
      System.out.println(res.v);
    }
  }
}