// start
package metaheuristicOptimization.examples.robocode;

import java.io.File;

import metaheuristicOptimization.LoggingObjectiveFunction;
import metaheuristicOptimization.algorithms.HC;
import metaheuristicOptimization.searchSpaces.Rn.Rn;
import metaheuristicOptimization.searchSpaces.Rn.RnNullaryUniform;
import metaheuristicOptimization.searchSpaces.Rn.RnUnaryNormal2;
import metaheuristicOptimization.termination.MaxSteps;

/** apply hill climbing to robocode! */
// end
public class HCOnRobocodeProgress {// start
  /**
   * the main routine
   * 
   * @param args
   *          ignored
   */
  // end
  public static void main(final String[] args) {
    final HC<double[], String> hc = new HC<>();
    final Rn rn = new Rn(-1.5d, 1.5d, 20);
    final LoggingObjectiveFunction<String> f;

    hc.gpm = new RobocodeGPM();
    hc.nullary = new RnNullaryUniform(rn);
    hc.unary = new RnUnaryNormal2(rn);
    hc.termination = new MaxSteps(50000);

    f = new LoggingObjectiveFunction<>(new RobocodeObjective(), new File("./logs/robocode"));
    f.beginRun();
    System.out.println(hc.solve(f));
    f.endRun();
  }
}
