// start
package metaheuristicOptimization.searchSpaces.Rn;

import java.util.Random;

import metaheuristicOptimization.IBinarySearchOperation;

/** discrete recombination */
// end
public class RnBinaryDiscrete extends Rn implements IBinarySearchOperation<double[]> {

  // start
  /**
   * instantiate this operation for a given subspace of the Rn
   * 
   * @param def
   *          the subspace
   */
  public RnBinaryDiscrete(final Rn def) {
    super(def);
  }

  /** {@inheritDoc} */
  @Override
  // end
  public double[] recombine(final double[] parent1, final double[] parent2, final Random r) {

    double[] res = parent1.clone();

    for (int i = parent2.length; (--i) >= 0;) {
      if (r.nextBoolean()) {
        res[i] = parent2[i];
      }
    }

    return res;
  }
}
