// start
package metaheuristicOptimization.searchSpaces.Rn;

import java.util.Random;

import metaheuristicOptimization.IBinarySearchOperation;

/** intermediate recombination */
// end
public class RnBinaryIntermediate extends Rn implements IBinarySearchOperation<double[]> {

  // start
  /**
   * instantiate this operation for a given subspace of the Rn
   * 
   * @param def
   *          the subspace
   */
  public RnBinaryIntermediate(final Rn def) {
    super(def);
  }

  /** {@inheritDoc} */
  @Override
  // end
  public double[] recombine(final double[] parent1, final double[] parent2, final Random r) {

    double[] res = new double[parent1.length];

    for (int i = parent2.length; (--i) >= 0;) {
      res[i] = (0.5d * (parent1[i] + parent2[i]));
    }

    return res;
  }
}
