// start
package metaheuristicOptimization.searchSpaces.Rn;

import java.util.Random;

import metaheuristicOptimization.ITernarySearchOperation;

/** the ternary recombination operator for PSO */
// end
public class RnRecombineDE extends Rn implements ITernarySearchOperation<double[]> {
  /** the strength */
  final double F; // start

  /**
   * create
   * 
   * @param def
   *          the range definition
   * @param f
   *          the strength
   */
  public RnRecombineDE(final Rn def, final double f) {
    super(def);
    this.F = f;
  }

  /**
   * recombine
   * 
   * @param g1
   *          the first parent
   * @param g2
   *          the second parent
   * @param g3
   *          the third parent
   * @param r
   *          the randomizer
   * @return the result
   */
  @Override
  // end
  public double[] recombine(final double[] g1, final double[] g2, final double[] g3, final Random r) {

    final double[] res = new double[g1.length];

    for (int i = res.length; (--i) >= 0;) {
      res[i] = Math.max(this.min, Math.min(this.max, //
          (g3[i] + (this.F * (g1[i] - g2[i])))));
    }

    return res;
  }
}
