// start
package metaheuristicOptimization.searchSpaces.Rn;

import java.util.Random;

/** a recombination operator for PSO */
// end
public class RnRecombineDEBin extends RnRecombineDE {
  /** the crossover rate */
  private final double cr;

  // start
  /**
   * create
   * 
   * @param def
   *          the range definition
   * @param f
   *          the strength
   * @param c
   *          the crossover rate
   */
  public RnRecombineDEBin(final Rn def, final double f, final double c) {
    super(def, f);
    this.cr = c;
  }

  /** {@inheritDoc} */
  @Override
  // end
  public double[] recombine(final double[] g1, final double[] g2, final double[] g3, final Random r) {

    final double[] res = g1.clone();

    for (int i = res.length; (--i) >= 0;) {
      if (r.nextDouble() < this.cr) {
        res[i] = Math.max(this.min, Math.min(this.max, //
            (g3[i] + (this.F * (g1[i] - g2[i])))));
      }
    }

    return res;
  }
}
