// start
package metaheuristicOptimization.searchSpaces.bits;

import java.util.Random;

import metaheuristicOptimization.IBinarySearchOperation;

/** a binary single-point crossover for bit strings */
// end
public class BitsBinarySPX implements IBinarySearchOperation<boolean[]> {// start
  /** instantiate */
  public BitsBinarySPX() {
    super();
  }

  /** {@inheritDoc} */
  @Override
  // end
  public boolean[] recombine(final boolean[] p1, final boolean[] p2, final Random r) {
    final boolean[] g;
    final int x;

    g = new boolean[p1.length]; // create empty bit string
    x = (1 + r.nextInt(g.length - 1)); // select crossover point
    System.arraycopy(p1, 0, g, 0, x); // copy from first parent
    System.arraycopy(p2, x, g, x, g.length - x);// copy from second parent

    return g; // return new bit string
  }
}
