// start
package metaheuristicOptimization.searchSpaces.bits;

import java.util.Random;

import metaheuristicOptimization.IBinarySearchOperation;

/** a binary uniform crossover for bit strings */
// end
public class BitsBinaryUX implements IBinarySearchOperation<boolean[]> {// start
  /** instantiate */
  public BitsBinaryUX() {
    super();
  }

  /** {@inheritDoc} */
  @Override
  // end
  public boolean[] recombine(final boolean[] p1, final boolean[] p2, final Random r) {
    final boolean[] g;

    g = p1.clone(); // copy first parent string
    for (int i = g.length; (--i) >= 0;) { // for all bits...
      if (r.nextBoolean()) {
        g[i] = p2[i];
      } // take value from p2 with probability 0.5
    }

    return g; // return new bit string
  }
}
