// start
package metaheuristicOptimization.searchSpaces.bits;

import java.util.Random;

import metaheuristicOptimization.IUnarySearchOperation;

/** a unary search operation that randomly flipping bits in a bit string */
// end
public class BitsUnaryFlip implements IUnarySearchOperation<boolean[]> {// start
  /** instantiate */
  public BitsUnaryFlip() {
    super();
  }

  /**
   * Mutate a bit string!
   * 
   * @param p
   *          the existing parent bit string
   * @param r
   *          the randomizer
   */
  @Override
  // end
  public boolean[] mutate(final boolean[] p, final Random r) {
    final boolean[] g;
    
    g = p.clone();                    // copy parent string
    do {                              // at least once, but maybe more often
      g[r.nextInt(g.length)] ^= true; // flip the bit
    } while (r.nextBoolean());        // maybe repeat (small chance for large changes
    return g;                         // return new bit string
  }
}
