package metaheuristicOptimization.searchSpaces.trees.data.math.arith;

import metaheuristicOptimization.searchSpaces.trees.data.Node;
import metaheuristicOptimization.searchSpaces.trees.data.NodeType;
import metaheuristicOptimization.searchSpaces.trees.data.math.RealFunction;

/** Floor a given number
 * @author Thomas Weise */
public class Floor extends RealFunction {
  /** a constant required by Java serialization */
  private static final long serialVersionUID = 1;

  /** Create a node with the given children
   * @param pchildren
   *          the child nodes
   * @param in
   *          the node information record */
  public Floor(final Node<?>[] pchildren, final NodeType<Floor> in) {
    super(pchildren, in);
  }

  /** Compute the floor value of a given number
   * @param data
   *          the context containing the data vector
   * @return the result of the computation */
  @Override public double compute(final double[] data) {
    return Math.floor(this.get(0).compute(data));
  }

  /** Fill in the text associated with this node
   * @param sb
   *          the string builder */
  @Override public void fillInText(final StringBuilder sb) {
    sb.append("floor"); //$NON-NLS-1$
    this.printSubExpression(0, sb);
  }
}