package metaheuristicOptimization.searchSpaces.trees.data.math.arith;

import metaheuristicOptimization.searchSpaces.trees.data.Node;
import metaheuristicOptimization.searchSpaces.trees.data.NodeType;
import metaheuristicOptimization.searchSpaces.trees.data.math.RealFunction;

/** Multiply two numbers
 * @author Thomas Weise */
public class Mul extends RealFunction {
  /** a constant required by Java serialization */
  private static final long serialVersionUID = 1;

  /** Create a node with the given children
   * @param pchildren
   *          the child nodes
   * @param in
   *          the node information record */
  public Mul(final Node<?>[] pchildren, final NodeType<Mul> in) {
    super(pchildren, in);
  }

  /** Multiply two values
   * @param data
   *          the context containing the data vector
   * @return the result of the computation */
  @Override public double compute(final double[] data) {
    return (this.get(0).compute(data) * this.get(1).compute(data));
  }

  /** Fill in the text associated with this node
   * @param sb
   *          the string builder */
  @Override public void fillInText(final StringBuilder sb) {
    this.printSubExpression(0, sb);
    sb.append('*');
    this.printSubExpression(1, sb);
  }
}