package metaheuristicOptimization.searchSpaces.trees.data.math.basic;

import metaheuristicOptimization.searchSpaces.trees.data.math.RealFunction;

/** A constant always returns a specific value
 * @author Thomas Weise */
public class Constant extends RealFunction {
  /** a constant required by Java serialization */
  private static final long serialVersionUID = 1;

  /** the constant value */
  public final double value;

  /** Create a constant
   * @param in
   *          the constant type
   * @param val
   *          the value */
  public Constant(final ConstantType in, final double val) {
    super(null, in);
    this.value = val;
  }

  /** Returns the constant value
   * @param data
   *          the context containing the data vector
   * @return the constant value */
  @Override public double compute(final double[] data) {
    return this.value;
  }

  /** Fill in the text associated with this node
   * @param sb
   *          the string builder */
  @Override public void fillInText(final StringBuilder sb) {
    sb.append(this.value);
  }
}