package metaheuristicOptimization.searchSpaces.trees.data.math.basic;

import metaheuristicOptimization.searchSpaces.trees.data.math.RealFunction;

/** A variable returns the value at a specific index of the data
 * @author Thomas Weise */
public class Variable extends RealFunction {
  /** a constant required by Java serialization */
  private static final long serialVersionUID = 1;

  /** the variable index */
  public final int index;

  /** Create a variable
   * @param in
   *          the node information record
   * @param idx
   *          the index */
  public Variable(final VariableType in, final int idx) {
    super(null, in);
    this.index = idx;
  }

  /** Returns the variable's value
   * @param data
   *          the context containing the data vector
   * @return the variable's value */
  @Override public double compute(final double[] data) {
    return data[this.index];
  }

  /** Fill in the text associated with this node
   * @param sb
   *          the string builder */
  @Override public void fillInText(final StringBuilder sb) {
    sb.append('x');
    sb.append('[');
    sb.append(this.index);
    sb.append(']');
  }
}