package metaheuristicOptimization.searchSpaces.trees.data.math.basic;

import java.util.Random;

import metaheuristicOptimization.searchSpaces.trees.data.Node;
import metaheuristicOptimization.searchSpaces.trees.data.NodeType;

/** A variable type
 * @author Thomas Weise */
public class VariableType extends NodeType<Variable> {
  /** the variables */
  public final Variable[] vars;

  /** Create a new variable type record
   * @param varc
   *          the variable count */
  public VariableType(final int varc) {
    super(null);
    int i;
    Variable[] v;
    this.vars = v = new Variable[varc];
    for (i = varc; (--i) >= 0;) {
      v[i] = new Variable(this, i);
    }
  }

  /** Instantiate a node
   * @param children
   *          a given set of children
   * @param r
   *          the randomizer
   * @return the new node */
  @Override public Variable instantiate(final Node<?>[] children, final Random r) {
    return this.vars[r.nextInt(this.vars.length)];
  }
}